<!DOCTYPE html>
<html lang="en">
{% include 'header.html' %}
<body>
<div id="segment_id">
    {% include 'menu.html' %}
    <script>
        $(function () {
            $('.ui.dropdown.selection').dropdown({});
            $('.message .close')
                .on('click', function () {
                    $(this)
                        .closest('.message')
                        .transition('fade')
                    ;
                });

            $('.menu .item').tab({
                history: true,
                historyType: 'hash'
            });

        });
    </script>
    <style>
        .ui.dropdown .menu {
            min-width: 100%;
        }

        .ui.dropdown.dropdown .menu > .input {
            min-width: 80%;
        }
    </style>
    <form class="ui form" method="post" novalidate>
        <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
        <div class="ui grid">
            <div class="ui column" style="width: 75px; padding-top: 50px;">
            </div>
            <div class="ui column" style="width: calc(100% - 75px);">
                <h1 class="ui dividing header" style="width: 190px; float: left;">Edit issue rule: </h1>
                <input class="ui input" id="rule_name" style="width: 300px; float: left;" placeholder="rule name" value="{{ current_rule['name'] }}" required>
                <div class="ui grid" style="float: left; width: 100%;">
                    <div class="two columns row" style="padding-bottom: 0">
                        <div class="ui column">
                            <div class="ui field" style="float: left; margin-bottom: 15px; max-width: 400px;">
                                <div class="ui labeled input">
                                    <div class="ui label" style="width: 125px;">
                                        <i class="users icon"></i>Owner:
                                    </div>
                                    <div class="ui fluid selection dropdown">
                                        <input type="hidden" id="team_id_field" name="team_id" value="{{ current_rule['team_id'] }}">
                                        <i class="dropdown icon"></i>
                                        <div class="default text">Select status</div>
                                        <div class="menu">
                                            <div class="item" data-value="">Personal account</div>
                                            {% set teams = db.select_user_teams(session['id']) %}
                                            {% for team in teams %}
                                                <div class="item" data-value="{{ team['id'] }}">Team: {{ escape(team['name']) }}</div>
                                            {% endfor %}
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="ui column">
                            <div class="ui field" style="float: right; margin-right: 27px; max-width: 400px;">
                                <button class="ui button purple" type="button" onclick="submit_new_rule();"><i class="icon sync"></i>Update</button>
                                <button class="ui button red" type="button" onclick="delete_current_rule();"><i class="icon trash"></i>Delete</button>
                            </div>
                        </div>
                    </div>
                    <div class="ui top attached tabular menu" style="margin-bottom: 10px;display: block;">
                        <a class="item active" data-tab="search" style="float:left;">
                            <i class="search icon"></i>Search rule
                        </a>
                        <i class="long arrow alternate right big icon green" style="margin-top: 7px;float: left;"></i>
                        <a class="item" data-tab="extract" style="float: left;">
                            <i class="share icon"></i>Extract variables
                        </a>
                        <i class="long arrow alternate right big icon green" style="margin-top: 7px;float: left;"></i>
                        <a class="item" data-tab="replace" style="float: left;">
                            <i class="edit icon"></i>Replace text
                        </a>
                        <a target="_blank" rel="noopener noreferrer" class="ui button item" href="https://gitlab.com/invuls/pentest-projects/pcf/-/wikis/Issue-rules#rules-logics" style="float: right;">
                            <i class="globe icon"></i>Wiki
                        </a>
                    </div>
                    <input type="hidden" name="csrf_token" value="{{ csrf_token() }}"/>
                    <div class="ui tab active" data-tab="search" style="width:100%">
                        <script>
                            search_table_obj = null;

                            action_buttons = `
                            <button type="button" onclick="up_search_rule_row(this);" class="ui icon button green"><i class="ui icon long arrow alternate up"></i></button>
                            <button type="button" onclick="down_search_rule_row(this);" class="ui icon button orange"><i class="ui icon long arrow alternate down"></i></button>
                            <button type="button" class="ui icon button red" onclick="delete_search_rule_row(this);">Delete</button>
                            `;


                            $(document).ready(function () {
                                search_table_obj = $('#search_table').DataTable({
                                    "order": [[0, "asc"]],
                                    "searching": false,
                                    "bLengthChange": false,
                                    "bAutoWidth": false,
                                    "iDisplayLength": -1,
                                    "paging": false,
                                    "bInfo": false,
                                    'columnDefs': [
                                        {
                                            'targets': "_all",
                                            'searchable': false,
                                            'orderable': false
                                        },
                                        {
                                            render: function (data, type, full, meta) {
                                                return "<div style='word-break: break-all;'>" + data + "</div>";
                                            },
                                            targets: 3
                                        }]
                                });
                            });

                            function add_search_rule() {
                                search_field_name = $('#search_field_name_val')[0].value;
                                search_type = $('#search_type')[0].value;
                                search_value = $('#search_value')[0].value;

                                last_counter = 0
                                if (search_table_obj.row(':last').data()) {
                                    last_counter = parseInt(search_table_obj.row(':last').data()[0]);
                                }

                                if (search_type !== "" && search_value !== "" && search_field_name !== "") {
                                    search_table_obj.row.add([
                                        last_counter + 1,
                                        search_field_name,
                                        search_type,
                                        search_value,
                                        action_buttons
                                    ]).draw(false);
                                    $('#search_value')[0].value = "";
                                    $('#search_field_name_val')[0].value = "";
                                } else {
                                    $('body').toast({
                                        class: 'error',
                                        position: 'bottom right',
                                        message: 'Some information was not set!'
                                    });
                                }
                            }

                            function update_search_rule_numbers() {
                                i = 1;
                                search_table_obj.rows().every(function (rowIdx, tableLoop, rowLoop) {
                                    var data = this.data();
                                    data[0] = i;
                                    i++;
                                    this.data(data);
                                });
                            }

                            function delete_search_rule_row(obj) {
                                var row = $(obj).parents('tr');
                                search_table_obj.row(row).remove().draw();
                                update_search_rule_numbers();
                            }

                            function up_search_rule_row(obj) {
                                var row = $(obj).parents('tr');
                                index = parseInt(row[0].children[0].textContent) - 1;
                                if (index > 0) {
                                    var data1 = search_table_obj.row(index).data();

                                    var data2 = search_table_obj.row(index - 1).data();

                                    search_table_obj.row(index).data(data2);
                                    search_table_obj.row(index - 1).data(data1);
                                    update_search_rule_numbers();
                                }

                            }

                            function down_search_rule_row(obj) {
                                var row = $(obj).parents('tr');
                                index = parseInt(row[0].children[0].textContent) - 1;
                                var data1 = search_table_obj.row(index).data();

                                var data2 = search_table_obj.row(index + 1).data();

                                search_table_obj.row(index).data(data2);
                                search_table_obj.row(index + 1).data(data1);
                                update_search_rule_numbers();

                            }

                            function set_search_filter(field_name, search_type, search_value) {
                                $('#search_field_name_val')[0].value = field_name;
                                $('#search_types_list').dropdown('set selected', search_type);
                                $('#search_value')[0].value = search_value;
                            }
                        </script>

                        <style>
                            tr.odd {
                                background-color: #fffdc2;
                            }

                            tr.even {
                                background-color: #c3ffcd;
                            }

                            .ui.menu:last-child {
                                margin-bottom: 0px;
                            }
                        </style>

                        <table id="search_table" class="ui table" style="width:100%">
                            <thead>
                            <tr>
                                <th style="width: 20px;">#</th>
                                <th>Field name</th>
                                <th>Type</th>
                                <th>Filter</th>
                                <th style="width: 160px;">Action</th>
                            </tr>
                            </thead>
                            {% set search_rules_arr = json_unpack(current_rule['search_rules']) %}
                            {% for rule_obj in search_rules_arr %}
                                <tr>
                                    <td>{{ loop.index }}</td>
                                    <td>{{ rule_obj['field_name'] }}</td>
                                    <td>{{ rule_obj['type'] }}</td>
                                    <td>{{ rule_obj['value'] }}</td>
                                    <td>
                                        <button type="button" onclick="up_search_rule_row(this);" class="ui icon button green"><i class="ui icon long arrow alternate up"></i></button>
                                        <button type="button" onclick="down_search_rule_row(this);" class="ui icon button orange"><i class="ui icon long arrow alternate down"></i></button>
                                        <button type="button" class="ui icon button red" onclick="delete_search_rule_row(this);">Delete</button>
                                    </td>
                                </tr>
                            {% endfor %}
                            <tbody>
                            </tbody>
                        </table>
                        <h3>New search filter</h3>
                        <form class="ui form">
                            <div class="four fields">
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Field:
                                        </div>
                                        <div class="ui input">
                                            <input required id="search_field_name_val" list="search_field_name" placeholder="Field name" type="text">
                                        </div>
                                        <datalist id="search_field_name">
                                            <option value="name">System: Name</option>
                                            <option value="description">System: Description</option>
                                            <option value="fix">System: Fix</option>
                                            <option value="url">System: URL path/service</option>
                                            <option value="cvss">System: CVSS</option>
                                            <option value="cve">System: CVE</option>
                                            <option value="cwe">System: CWE</option>
                                            <option value="status">System: Status</option>
                                            <option value="criticality">System: Criticality (cvss-based)</option>
                                            <option value="parameter">System: Parameter</option>
                                            <option value="__example__">Additional field: __example__</option>
                                        </datalist>
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Type:
                                        </div>
                                        <div class="ui fluid selection dropdown" id="search_types_list">
                                            <input type="hidden" id="search_type" name="status" required>
                                            <i class="dropdown icon"></i>
                                            <div class="default text">Select type</div>
                                            <div class="menu">
                                                <div class="item" data-value="RegExp">Regular expression (.*)</div>
                                                <div class="item" data-value="Substring">Substring (% some_text % another_text %)</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Value:
                                        </div>
                                        <input type="text" name="name" id="search_value" placeholder="% some_text % /  some_text[0-9]*" required value="">
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <button type="button" class="ui button green" onclick="add_search_rule();">Add filter</button>
                                </div>
                            </div>
                        </form>
                        <h3>Examples</h3>
                        <button type="button" style="margin-bottom: 15px;" class="ui button blue" onclick="set_search_filter('__nessus_plugin_id__', 'Substring', 1337);">Nessus special plugin ID</button>
                        <button type="button" class="ui yellow button" onclick="set_search_filter('name', 'Substring', '%SQL%');">Issues with "SQL" in name</button>
                        <button type="button" class="ui violet button" onclick="set_search_filter('criticality', 'Substring', 'critical');">Critical vulnerabilities</button>
                        <button type="button" class="ui red button" onclick="set_search_filter('cwe', 'Substring', '1337');">Certain CWE</button>
                        <button type="button" class="ui pink button" onclick="set_search_filter('description', 'RegExp', '^[\\s\\S]*(XSS|CSRF)[\\s\\S]*$');">"XSS" or "CSRF" in description.</button>
                    </div>
                    <div class="ui tab" data-tab="extract" style="width: 100%;">
                        <script>
                            extract_table_obj = null;

                            extract_variables = {};

                            extract_action_buttons = `
                            <button type="button" class="ui icon button red" onclick="delete_extract_row(this);">Delete</button>
                            `;


                            $(document).ready(function () {
                                extract_table_obj = $('#extract_table').DataTable({
                                    "searching": false,
                                    "bLengthChange": false,
                                    "bAutoWidth": false,
                                    "iDisplayLength": -1,
                                    "paging": false,
                                    "bInfo": false,
                                    'columnDefs': [
                                        {
                                            'targets': "_all",
                                            'searchable': false,
                                            'orderable': false
                                        },
                                        {
                                            render: function (data, type, full, meta) {
                                                return "<div style='word-break: break-all;'>" + data + "</div>";
                                            },
                                            targets: '_all'
                                        }]
                                });

                                // load extract_variables
                                for (let row of Array.from(extract_table_obj.rows().data())) {
                                    extract_variables[row[1]] = null;
                                }
                            });


                            function add_extract_rule() {
                                extract_field_name = $('#extract_field_name_val')[0].value;
                                extract_type = $('#extract_type')[0].value;
                                extract_variable_name = $('#extract_variable_name')[0].value;
                                extract_value = $('#extract_value')[0].value;


                                if (!$('#extract_variable_name')[0].validity.valid) {
                                    $('body').toast({
                                        class: 'error',
                                        position: 'bottom right',
                                        message: 'Wrong variable name! [a-zA-Z0-9_]+'
                                    });
                                    return;
                                }

                                if (extract_variables.hasOwnProperty(extract_variable_name)) {
                                    $('body').toast({
                                        class: 'error',
                                        position: 'bottom right',
                                        message: 'This variable name already exists!'
                                    });
                                    return;
                                } else {
                                    extract_variables[extract_variable_name] = "";
                                }

                                if (extract_field_name !== "" && extract_type !== "" && extract_variable_name !== "" && extract_value !== "") {
                                    extract_table_obj.row.add([
                                        extract_field_name,
                                        extract_variable_name,
                                        extract_type,
                                        extract_value,
                                        extract_action_buttons
                                    ]).draw(false);
                                    $('#extract_field_name_val')[0].value = "";
                                    $('#extract_variable_name')[0].value = "";
                                    $('#extract_value')[0].value = "";
                                } else {
                                    $('body').toast({
                                        class: 'error',
                                        position: 'bottom right',
                                        message: 'Some information was not set!'
                                    });
                                }
                            }


                            function delete_extract_row(obj) {
                                var row = $(obj).parents('tr');
                                extract_table_obj.row(row).remove().draw();
                                update_search_rule_numbers();
                            }

                            function set_extract_filter(field_name, var_name, search_type, extract_value) {
                                $('#extract_field_name_val')[0].value = field_name;
                                $('#extract_variable_name')[0].value = var_name;

                                $('#extract_list').dropdown('set selected', search_type);
                                $('#extract_value')[0].value = extract_value;
                            }

                        </script>
                        <table id="extract_table" class="ui table" style="width:100%">
                            <thead>
                            <tr>
                                <th>Field name</th>
                                <th>Variable name</th>
                                <th>Extract type</th>
                                <th>Filter</th>
                                <th style="width: 160px;">Action</th>
                            </tr>
                            </thead>
                            <tbody>
                            {% set extract_vars_arr = json_unpack(current_rule['extract_vars']) %}
                            {% for rule_obj in extract_vars_arr %}
                                <tr>
                                    <td>{{ rule_obj['field_name'] }}</td>
                                    <td>{{ rule_obj['name'] }}</td>
                                    <td>{{ rule_obj['type'] }}</td>
                                    <td>{{ rule_obj['value'] }}</td>
                                    <td>
                                        <button type="button" class="ui icon button red" onclick="delete_extract_row(this);">Delete</button>
                                    </td>
                                </tr>
                            {% endfor %}
                            </tbody>
                        </table>
                        <h3>New extract variable rule</h3>
                        <form class="ui form">
                            <div class="five fields">
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Field:
                                        </div>
                                        <div class="ui input">
                                            <input required id="extract_field_name_val" list="search_field_name" placeholder="Field name" type="text">
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Name:
                                        </div>
                                        <div class="ui input">
                                            <input required id="extract_variable_name" placeholder="a-zA-Z0-9_" pattern="[a-zA-Z0-9_]+" type="text">
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Type:
                                        </div>
                                        <div class="ui fluid selection dropdown" id="extract_list">
                                            <input type="hidden" id="extract_type" name="status" required>
                                            <i class="dropdown icon"></i>
                                            <div class="default text">Select type</div>
                                            <div class="menu">
                                                <div class="item" data-value="RegExp">Regular expression (.*)</div>
                                                <div class="item" data-value="Substring">Substring (% some_text % another_text %)</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Value:
                                        </div>
                                        <input type="text" name="name" id="extract_value" placeholder="%text<>text% / .*text(.*)text.*" required value="">
                                    </div>
                                </div>
                                <div class="ui field" style="width: 300px;">
                                    <button type="button" class="ui button green" onclick="add_extract_rule();">Add filter</button>
                                </div>
                            </div>
                        </form>
                        <h3>Examples</h3>
                        <button type="button" class="ui button blue" style="margin-bottom: 15px;" onclick="set_extract_filter('__nessus_plugin_id__','nessus_id','Substring', '<>');">Nessus ID variable</button>
                        <button type="button" class="ui yellow button" onclick="set_extract_filter('description','username','RegExp', '^[\\s\\S]*Username:\ ([^ ]+)\ [\\s\\S]*$')">Used username variable</button>
                        <button type="button" class="ui violet button" onclick="set_extract_filter('name','issue_name','Substring', '<>')">Issue name variable</button>
                        <button type="button" class="ui red button" onclick="set_extract_filter('name','issue_name_regexp','RegExp', '^([\\s\\S]*)$')">Issue name variable(RegExp)</button>

                    </div>
                    <div class="ui tab" data-tab="replace" style="width: 100%">
                        <script>

                            replace_template_table = null;
                            replace_substring_table = null;

                            template_array = [];

                            template_action_buttons = `
                                <button type="button" class="ui icon button red" onclick="delete_replace_template_row(this);">Delete</button>
                                <a target="_blank" rel="noopener noreferrer" class="ui icon button blue" href="/issue_template/TEMPLATE_ID/"><i class="linkify icon"></i></a>
                            `;

                            string_replace_action_buttons = `
                            <button type="button" onclick="move_up_replace_substring(this);" class="ui icon button green"><i class="ui icon long arrow alternate up"></i></button>
                            <button type="button" onclick="move_down_substring_replace(this);" class="ui icon button orange"><i class="ui icon long arrow alternate down"></i></button>
                            <button type="button" class="ui icon button red" onclick="delete_replace_substring_row(this);">Delete</button>
                            `

                            template_var_input = `
                            <div class="ui labeled input">
                                <div class="ui label">
                                    <i class="at icon"></i>TEMPLATE_VAR:
                                </div>
                                <div class="ui input">
                                    <input required id="TEMPLATE_ID-TEMPLATE_VAR" type="text" value="TEMPLATE_VAR_DEFAULT" placeholder="{{ '..text..{{var_name_step2}}..text..' }}">
                                </div>
                            </div>
                            `

                            $(document).ready(function () {
                                $('#hint_replace_substring')
                                    .popup({
                                        position: 'right center',
                                        content: "These rules will be used to replace string pattern with another string/variable.",
                                        offset: 20,
                                    });
                                $('#hint_replace_templates')
                                    .popup({
                                        position: 'right center',
                                        content: "These rules will be used to replace issue with issue template.",
                                        offset: 20,
                                    });

                                $('#template_dropdown').dropdown({
                                    match: 'text',
                                    ignoreCase: true,
                                    fullTextSearch: true

                                });


                                replace_template_table = $('#replace_templates_table').DataTable({
                                    "order": [[0, "asc"]],
                                    "searching": false,
                                    "bLengthChange": false,
                                    "bAutoWidth": false,
                                    "iDisplayLength": -1,
                                    "paging": false,
                                    "bInfo": false,
                                    'columnDefs': [
                                        {
                                            'targets': "_all",
                                            'searchable': false,
                                            'orderable': false
                                        },
                                        {
                                            render: function (data, type, full, meta) {
                                                return "<div style='word-break: break-all;'>" + data + "</div>";
                                            },
                                            targets: 3
                                        }]
                                });

                                replace_substring_table = $('#replace_substrings_table').DataTable({
                                    "order": [[0, "asc"]],
                                    "searching": false,
                                    "bLengthChange": false,
                                    "bAutoWidth": false,
                                    "iDisplayLength": -1,
                                    "paging": false,
                                    "bInfo": false,
                                    'columnDefs': [
                                        {
                                            'targets': "_all",
                                            'searchable': false,
                                            'orderable': false
                                        },
                                        {
                                            render: function (data, type, full, meta) {
                                                return "<div style='word-break: break-all;'>" + data + "</div>";
                                            },
                                            targets: 3
                                        }]
                                });
                                update_templates_numbers();
                            });

                            function encodeHTMLEntities(text) {
                                var textArea = document.createElement('textarea');
                                textArea.innerText = text;
                                tmp = textArea.innerHTML;
                                textArea.remove();
                                return tmp;
                            }

                            function select_template(obj) {
                                template_vars_list = $('#template_vars_list')[0];
                                template_vars_list.innerHTML = "";
                                template_vars = JSON.parse(obj.getAttribute("data-value"));
                                template_id = obj.getAttribute("data-id");
                                new_html = "";
                                for (var key in template_vars) {
                                    tmp_html = template_var_input.replaceAll("TEMPLATE_VAR_DEFAULT", encodeHTMLEntities(template_vars[key]["value"]));
                                    tmp_html = tmp_html.replaceAll("TEMPLATE_VAR", key);
                                    tmp_html = tmp_html.replaceAll("TEMPLATE_ID", template_id);
                                    new_html += tmp_html;
                                }
                                template_vars_list.innerHTML = new_html;
                            }

                            function add_template() {
                                dropdown_obj = $('#template_dropdown');

                                selected_obj = dropdown_obj.find(".selected")[0];

                                if (!selected_obj) {
                                    $('body').toast({
                                        class: 'error',
                                        position: 'bottom right',
                                        message: 'Need to select template!'
                                    });
                                    return;
                                }
                                template_id = selected_obj.getAttribute("data-id");
                                template_vars = JSON.parse(selected_obj.getAttribute("data-value"));
                                template_name = selected_obj.innerText.trim()

                                new_template_obj = {'id': template_id, 'vars': {}}

                                vars_html = "";

                                for (var var_name in template_vars) {
                                    var_value = $('#' + template_id + "-" + var_name)[0].value;
                                    new_template_obj['vars'][var_name] = var_value;
                                    vars_html += var_name + "=`" + encodeHTMLEntities(var_value) + "`;</br>";
                                }
                                replace_template_table.row.add([
                                    "99999999999",
                                    template_name,
                                    vars_html,
                                    template_action_buttons.replaceAll("TEMPLATE_ID", template_id)
                                ]).draw(false);
                                // add json data
                                // {"template_id": "id", "vars":{"name":"urlpath", "value": "test"}, ... }
                                $('#replace_templates_table').find("tr").slice(-1)[0].children[1].setAttribute("data-value", JSON.stringify(new_template_obj));

                                update_templates_numbers();
                            }

                            function update_templates_numbers() {
                                i = 1;
                                replace_template_table.rows().every(function (rowIdx, tableLoop, rowLoop) {
                                    var data = this.data();
                                    data[0] = i;
                                    i++;
                                    this.data(data);
                                });

                                replace_substring_table.rows().every(function (rowIdx, tableLoop, rowLoop) {
                                    var data = this.data();
                                    data[0] = i;
                                    i++;
                                    this.data(data);
                                });
                            }

                            function delete_replace_template_row(obj) {
                                var row = $(obj).parents('tr');
                                replace_template_table.row(row).remove().draw();
                                update_templates_numbers();
                            }

                            function add_replace_substring() {

                                replace_string_type = $('#replace_string_type')[0].value;
                                field_name = $('#replace_field_name_val')[0].value;
                                search_filter = $('#search_replace_string_filter')[0].value;
                                replace_value = $('#replace_string_value')[0].value;

                                if (field_name !== "" && replace_string_type !== "" && search_filter !== "") {
                                    replace_substring_table.row.add([
                                        "99999999999",
                                        replace_string_type,
                                        field_name,
                                        search_filter,
                                        replace_value,
                                        string_replace_action_buttons
                                    ]).draw(false);
                                    update_templates_numbers();
                                } else {
                                    $('body').toast({
                                        class: 'error',
                                        position: 'bottom right',
                                        message: 'Some fields were not filled!'
                                    });
                                }
                            }

                            function move_up_replace_substring(obj) {
                                var row = $(obj).parents('tr');
                                index = parseInt(row[0].children[0].textContent) - 1 - replace_template_table.rows().data().length;
                                if (index > 0) {
                                    var data1 = replace_substring_table.row(index).data();

                                    var data2 = replace_substring_table.row(index - 1).data();

                                    replace_substring_table.row(index).data(data2);
                                    replace_substring_table.row(index - 1).data(data1);
                                    update_templates_numbers();
                                }
                            }

                            function move_down_substring_replace(obj) {
                                var row = $(obj).parents('tr');
                                index = parseInt(row[0].children[0].textContent) - 1 - replace_template_table.rows().data().length;
                                var data1 = replace_substring_table.row(index).data();

                                var data2 = replace_substring_table.row(index + 1).data();

                                replace_substring_table.row(index).data(data2);
                                replace_substring_table.row(index + 1).data(data1);
                                update_templates_numbers();
                            }

                            function delete_replace_substring_row(obj) {
                                var row = $(obj).parents('tr');
                                replace_substring_table.row(row).remove().draw();
                                update_templates_numbers();
                            }

                            function set_replace_rule(replace_type, field_name, search_filter, replace_str) {
                                $('#replace_field_name_val')[0].value = field_name;
                                $('#search_replace_string_filter')[0].value = search_filter;
                                $('#replace_string_value')[0].value = replace_str;

                                $('#replace_list').dropdown('set selected', replace_type);
                            }

                        </script>
                        <h2 style="float: left;">Replace templates</h2>
                        <div id="hint_replace_templates" style="float: left;"><i class="ui icon question yellow" style="float:left; padding-top: 30px;"></i></div>
                        <table id="replace_templates_table" class="ui table" style="width:100%">
                            <thead>
                            <tr>
                                <th>#</th>
                                <th>Template name</th>
                                <th>Template variables</th>
                                <th style="width: 160px;">Action</th>
                            </tr>
                            </thead>
                            <tbody>
                            {% set extract_vars_arr = json_unpack(current_rule['replace_rules']) %}
                            {% set template = {'obj': False} %}
                            {% for rule_obj in extract_vars_arr %}
                                {% if rule_obj['type'] == 'template' %}
                                    {% if template.update({'obj': db.check_user_issue_template_access( rule_obj['id'], current_user['id'], current_user['email'] )}) %}{% endif %}
                                    {% if template.obj %}
                                        <tr>
                                            <td>999999999</td>
                                            <td data-value="{{ json_pack(rule_obj) }}">{{ template.obj[0]['tpl_name'] }}</td>
                                            <td>
                                                {% for var_name in rule_obj['vars'] %}
                                                    {{ var_name }}=`{{ rule_obj['vars'][var_name] }}`<br/>
                                                {% endfor %}
                                            </td>
                                            <td>
                                                <button type="button" class="ui icon button red" onclick="delete_replace_template_row(this);">Delete</button>
                                                <a target="_blank" rel="noopener noreferrer" class="ui icon button blue" href="/issue_template/{{ template.obj[0]['id'] }}/"><i class="linkify icon"></i></a>
                                            </td>
                                        </tr>
                                    {% endif %}
                                {% endif %}
                            {% endfor %}
                            </tbody>
                        </table>
                        <h3>Add "replace with template" rule</h3>
                        <h5 style="color: red !important;">Careful! If you want your teammates to use this rule too, select only team templates!!!</h5>
                        <form class="ui form">
                            <div class="three fields">
                                <div class="ui field">
                                    <div class="ui floating dropdown labeled icon button violet" id="template_dropdown">
                                        <i class="down arrow icon"></i>
                                        <span class="text">Select issue template</span>
                                        <div class="menu" style="z-index: 999;">
                                            <div class="ui icon search input" style="width: 300px;">
                                                <i class="search icon"></i>
                                                <input type="text" placeholder="Search template...">
                                            </div>
                                            <div class="divider"></div>
                                            <div class="header">
                                                <i class="tags icon"></i>
                                                Issue templates
                                            </div>
                                            <div class="scrolling menu">
                                                <a target="_blank" rel="noopener noreferrer" class="item" href="/profile#/config" style="white-space:normal; word-break: break-all">
                                                    <div></div>
                                                    <i class="yellow star outline icon"></i>Create a new template
                                                </a>
                                                {% set issue_templates = db.select_user_issue_templates(current_user['id']) %}
                                                {% for current_template in issue_templates %}
                                                    {% if current_template['cvss'] == 0 %}
                                                        {% set template_color = 'blue' %}
                                                    {% elif current_template['cvss'] <=3.9 %}
                                                        {% set template_color = 'green' %}
                                                    {% elif current_template['cvss'] <= 6.9 %}
                                                        {% set template_color = 'yellow' %}
                                                    {% elif current_template['cvss'] <= 8.9 %}
                                                        {% set template_color = 'orange' %}
                                                    {% else %}
                                                        {% set template_color = 'red' %}
                                                    {% endif %}
                                                    <div rel="noopener noreferrer" class="item" data-id="{{ current_template['id'] }}" data-value="{{ current_template['variables'] }}" style="width: 100%; white-space:normal; word-break: break-all" onclick="select_template(this);">
                                                        <div class="ui {{ template_color }} empty circular label"></div>
                                                        {{ escape(current_template['tpl_name']) }} ({% if current_template['user_id'] %}Personal{% else %}Team: {{ db.select_team_by_id(current_template['team_id'])[0]['name'] }}{% endif %})
                                                    </div>
                                                {% endfor %}
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" id="template_vars_list">
                                </div>
                                <div class="ui field">
                                    <button type="button" class="ui button green" onclick="add_template();">Add template rule</button>
                                </div>
                            </div>
                        </form>
                        <h2 style="float: left;">Replace substrings</h2>
                        <div id="hint_replace_substring" style="float: left;"><i class="ui icon question yellow" style="float:left; padding-top: 30px;"></i></div>
                        <table id="replace_substrings_table" class="ui table" style="width:100%">
                            <thead>
                            <tr>
                                <th>#</th>
                                <th>Replace type</th>
                                <th>Field name</th>
                                <th>Search filter</th>
                                <th>Replace string</th>
                                <th style="width: 160px;">Action</th>
                            </tr>
                            </thead>
                            <tbody>
                            {% for rule_obj in extract_vars_arr %}
                                {% if rule_obj['type'] != 'template' %}
                                    <tr>
                                        <td>999999999</td>
                                        <td>{{ rule_obj['type'] }}</td>
                                        <td>{{ rule_obj['field_name'] }}</td>
                                        <td>{{ rule_obj['search_filter'] }}</td>
                                        <td>{{ rule_obj['replace_string'] }}</td>
                                        <td>
                                            <button type="button" onclick="move_up_replace_substring(this);" class="ui icon button green"><i class="ui icon long arrow alternate up"></i></button>
                                            <button type="button" onclick="move_down_substring_replace(this);" class="ui icon button orange"><i class="ui icon long arrow alternate down"></i></button>
                                            <button type="button" class="ui icon button red" onclick="delete_replace_substring_row(this);">Delete</button>
                                        </td>
                                    </tr>
                                {% endif %}
                            {% endfor %}
                            </tbody>
                        </table>

                        <h3>Add "replace with string" rule</h3>
                        <form class="ui form">
                            <div class="ui five fields">
                                <div class="ui field" style="max-width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Type:
                                        </div>
                                        <div class="ui fluid selection dropdown" id="replace_list">
                                            <input type="hidden" id="replace_string_type" required>
                                            <i class="dropdown icon"></i>
                                            <div class="default text">Select type</div>
                                            <div class="menu">
                                                <div class="item" data-value="RegExp">Regular expression (.*)</div>
                                                <div class="item" data-value="Substring">Substring ( some_text )</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" style="max-width: 300px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Field:
                                        </div>
                                        <div class="ui input">
                                            <input required id="replace_field_name_val" list="search_field_name" placeholder="Field name" type="text">
                                        </div>
                                    </div>
                                </div>
                                <div class="ui field" style="max-width: 400px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Search filter:
                                        </div>
                                        <input type="text" name="name" id="search_replace_string_filter" placeholder="some_string / .*text(.*)text.*" required value="">
                                    </div>
                                </div>
                                <div class="ui field" style="max-width: 400px;">
                                    <div class="ui labeled input">
                                        <div class="ui label">
                                            <i class="at icon"></i>Replace value:
                                        </div>
                                        <input type="text" name="name" id="replace_string_value" placeholder="new_string / {{ '..text..{{var_name_step2}}..text..' }}" required value="">
                                    </div>
                                </div>
                                <div class="ui field" style="max-width: 300px;">
                                    <button class="ui green button" type="button" onclick="add_replace_substring();">Add string replace rule</button>
                                </div>
                            </div>
                        </form>
                        <h3>Examples</h3>
                        <button type="button" class="ui button blue" style="margin-bottom: 15px;" onclick="set_replace_rule('Substring', 'name', 'Nessus: ', '');">Delete "Nessus: " at name</button>
                        <button type="button" class="ui yellow button" onclick="set_replace_rule('RegExp','description','^[\\s\\S]*$', 'Some text example')">Replace description</button>
                        <button type="button" class="ui violet button" onclick="set_replace_rule('RegExp','name','^[\\s\\S]*$', '{{ '{{name}}' }}')">Replace name with "name" variable</button>

                    </div>
                </div>
            </div>
        </div>
    </form>

    <script>
        function submit_new_rule() {
            /*
            1 - Collect search rules

            2 - Collect extract variables

            3 - Collect replace text rules
                3.1 Check if used







            {{ '{{var_name}}' }} is located at part2
            4 - Submit rule
            */

            part1_search_rule_data = [];
            part2_extract_rule_data = [];
            part2_vars_list = {};
            part3_replace_rule_data = [];

            /* ****************************** */
            // Part 1 - collect search rules
            /* ****************************** */

            search_data = Array.from(search_table_obj.rows().data());

            part1_search_rule_data = [];

            if (search_data.length === 0) {
                $('body').toast({
                    class: 'error',
                    position: 'bottom right',
                    message: 'Please, add search rules!'
                });
                return;
            }

            for (let row of search_data) {
                new_obj = {
                    'field_name': row[1],
                    'rule_type': row[2].toLowerCase(),
                    'value': row[3]
                }
                part1_search_rule_data.push(new_obj);
            }

            /* ****************************** */
            // Part 2 - collect extract rules
            /* ****************************** */

            extract_table_data = Array.from(extract_table_obj.rows().data());
            for (let row of extract_table_data) {

                new_obj = {
                    'field_name': row[0],
                    'var_name': row[1],
                    'extract_type': row[2].toLowerCase(),
                    'value': row[3]
                }

                part2_extract_rule_data.push(new_obj);
                part2_vars_list[row[1]] = null;

            }

            /* ****************************** */
            // Part 3 - collect replace rules
            /* ****************************** */

            // Collect templates

            template_rows = $('#replace_templates_table').find("tr.odd,tr.even");
            if (template_rows[0].innerText === 'No data available in table') {
                var template_rows = [];
            }
            regexp_vars = /\{\{[a-zA-Z0-9_]+\}\}/g;
            for (let row of template_rows) {
                // {"id": "...", "vars": {"service-name": "protail"}}
                template_object = JSON.parse(row.children[1].getAttribute("data-value"));
                template_id = template_object["id"];
                template_vars = template_object["vars"];

                for (var var_name in template_vars) {
                    var result = template_vars[var_name].match(regexp_vars);
                    if (result === null) {
                        result = [];
                    }
                    for (var_step2 of result) {
                        var_real_name = var_step2.replaceAll("{", "").replaceAll("}", "");
                        if (!part2_vars_list.hasOwnProperty(var_real_name)) {
                            $('body').toast({
                                class: 'error',
                                position: 'bottom right',
                                message: 'You\'re trying to use ' + var_step2 + ' which was not created at step2!'
                            });
                            return;
                        }
                    }
                }
                new_template_obj = {
                    "id": template_id,
                    "vars": template_vars
                }
                part3_replace_rule_data.push(new_template_obj);

            }

            // collect replace table

            replace_substring_data = Array.from(replace_substring_table.rows().data());
            for (let row of replace_substring_data) {
                replace_type = row[1].toLowerCase();
                field_name = row[2];
                search_filter = row[3];
                replace_string = row[4];


                var result = replace_string.match(regexp_vars);
                if (result === null) {
                    result = [];
                }
                for (var_step2 of result) {
                    var_real_name = var_step2.replaceAll("{", "").replaceAll("}", "");
                    if (!part2_vars_list.hasOwnProperty(var_real_name)) {
                        $('body').toast({
                            class: 'error',
                            position: 'bottom right',
                            message: 'You\'re trying to use ' + var_step2 + ' which was not created at step2!'
                        });
                        return;
                    }
                }

                new_replace_string_object = {
                    "type": replace_type,
                    "field_name": field_name,
                    "search_filter": search_filter,
                    "replace_string": replace_string
                }
                part3_replace_rule_data.push(new_replace_string_object);
            }

            $.post("/issue_rule/{{ current_rule['id'] }}/update", {
                name: $('#rule_name')[0].value,
                team_id: $('#team_id_field')[0].value,
                search_rule_json: JSON.stringify(part1_search_rule_data),
                extract_rule_json: JSON.stringify(part2_extract_rule_data),
                replace_rule_json: JSON.stringify(part3_replace_rule_data),
                csrf_token: "{{ csrf_token() }}"
            }).done(function (data) {
                json_data = JSON.parse(data);
                if (json_data['status'] === "ok") {
                    $('body').toast({
                        class: 'success',
                        position: 'bottom right',
                        message: "Updated successfully!"
                    });
                    return;
                }
                $('body').toast({
                    class: 'error',
                    position: 'bottom right',
                    message: data['error']
                });
            });
        }


        function delete_current_rule() {
            if (confirm("Are you sure to delete an issue rule?")) {
                $.post("/issue_rule/{{ current_rule['id'] }}/delete", {
                    csrf_token: "{{ csrf_token() }}"
                }).done(function (data) {
                    json_data = JSON.parse(data);
                    if (json_data['status'] === "ok") {
                        location.href = json_data['redirect'];
                        return;
                    }
                    $('body').toast({
                        class: 'error',
                        position: 'bottom right',
                        message: "Problem with removing this issue rule!"
                    });
                });
            }
        }
    </script>

</div>
{% include 'footer.html' %}
</body>
</html>